Status: Closed

Priority: Normal

Assignee: Ewoud Kohl van Wijngaarden
Category: Foreman modules

Target version:

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1487107 Red Hat JIRA:

Pull request: https://github.com/theforeman/puppet-for

eman_proxy/pull/374,
https://github.com/theforeman/puppet-for
eman_proxy/pull/376

Description

Grub2 have a regression when MAC-based loading of configs does not work, due to string manipulation in Red Hat patches MAC
always ands with ":" or "-" character:

RRQ from 10.87.1.231 filename /grub2/grub.cfg-01-96-48-EE-44-80-43-
The correct path is:
RRQ from 10.87.1.231 filename /grub2/grub.cfg-01-96-48-EE-44-80-43

We file a bug and RH team is going to fix this, but we need a workaround as more and more users are hitting this. In order to have
that workaround, we need regexp module which is unfortunately not present in grub2 build. Instead of copying the grub2 from EFI
directory, we can refactor our puppet code to build the grub2 like debian does:

/usr/bin/grub2-mkimage -0 x86_64-efi -d /usr/lib/grub/x86_64-efi -o /var/lib/tftpboot/grub2/grubx6
4.efi -p "' all_video boot btrfs cat chain configfile echo efifwsetup efinet ext2 fat font gettext
gfxmenu gfxterm gfxterm background gzio halt hfsplus i1is09660 jpeg keystatus loadenv linux lsefi 1
sefimmap lsefisystab lssal memdisk minicmd normal part_apple part_msdos part_gpt password_pbkdf2 p
ng reboot search search_fs_uuid search_fs_file search_label sleep test true video zfs zfscrypt zfs
info linuxefi lvm mdraid09 mdraidlx raidbSrec raidé6rec tftp regexp

Then the workaround is to use updated grub2 global template:

https://github.com/Izap/community-templates/blob/f21c8b275737243533d9b9d7c856e35fa988859b/provisioning_templates/PXEGrub
2/pxegrub2_global_default.erb

That will get the MAC and load correct file once it falls back to grub2.cfg.

Related issues:
Related to Installer - Bug #24653: Grub workaround for RHEL 7.4 should be onl... Closed

Associated revisions

Revision 0dfe6014 - 10/03/2017 10:58 AM - Ewoud Kohl van Wijngaarden
Fixes #21006 - Enable workaround for broken grub2 in EL7.4

History

#1 - 09/19/2017 09:33 AM - Lukas Zapletal
For the record the RHEL bugreport is at https://bugzilla.redhat.com/show_bug.cgi?id=1487107

#2 - 09/26/2017 07:51 AM - Ewoud Kohl van Wijngaarden
- Bugzilla link set to 1487107
https://github.com/lzap/community-templates/blob/f21c8b275737243533d9b9d7c856e35fa988859b/provisioning_templates/PXEGrub2/pxegrub2_global_default.erb
https://github.com/lzap/community-templates/blob/f21c8b275737243533d9b9d7c856e35fa988859b/provisioning_templates/PXEGrub2/pxegrub2_global_default.erb
https://bugzilla.redhat.com/show_bug.cgi?id=1487107

#3 - 09/26/2017 07:53 AM - The Foreman Bot
- Status changed from New to Ready For Testing
- Assignee set to Ewoud Kohl van Wijngaarden

- Pull request https://github.com/theforeman/puppet-foreman_proxy/pull/374 added

#4 - 09/26/2017 11:36 AM - Daniel Lobato Garcia

Lukas, Ewoud, 1.16 blocker?

#5 - 09/27/2017 07:19 AM - Ewoud Kohl van Wijngaarden

It could be and I'd also consider a backport to 1.15.

#6 - 10/02/2017 11:51 AM - The Foreman Bot
- Pull request https://github.com/theforeman/puppet-foreman_proxy/pull/376 added

#7 - 10/03/2017 12:17 PM - Anonymous
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset puppet-foreman_proxy|0dfe601438cf8b891d56112c5dc1ea92c6ae0885.

#8 - 08/17/2018 11:55 PM - Stephen Benjamin
- Related to Bug #24653: Grub workaround for RHEL 7.4 should be only for 7.4 added
